# ggplot2 hinzufügen
install.packages("ggplot2")
library("ggplot2")

# Streudiagramm
olympia <- data.frame(JAHR=c(2002,2006,2010,2014),
                      GOLD=c(12,11,10,8),
                      TEILNEHMER=c(157,164,153,153))

ggplot(data=olympia,aes(x=JAHR,y=GOLD,colour=TEILNEHMER)) + layer(geom="point",size=10)#Bild1
ggplot(data=olympia,aes(x=JAHR,y=GOLD,colour=TEILNEHMER)) + geom_point(size=10)
ggplot(data=olympia,aes(x=JAHR,y=GOLD,colour=TEILNEHMER)) + geom_line(size=5)#Bild2

# Liniengrafik
olympia$SILBER <- c(16,12,13,6)
olympia$BRONZE <- c(2, 7, 6, 5)

ggplot(data=olympia,aes(x=JAHR)) + geom_line(aes(y=GOLD),colour="yellow",size=2) + geom_line(aes(y=SILBER),colour="darkgrey",size=2) + geom_line(aes(y=BRONZE),colour="brown",size=2)

#Rechnen
df <- read.table("Winter.csv",header=TRUE, sep=";", fileEncoding="MAC") # einlesen
#df <- read.table("Winter.csv",header=TRUE, sep=";") # einlesen

install.packages("sqldf")
library("sqldf")

olympia2 <- sqldf("select JAHR, 
                  GOLD as ANZAHL,
                  'gold' as FARBE
                  from df
                  union select JAHR, 
                  SILBER as ANZAHL,
                  'silber' as FARBE
                  from df
                  union select JAHR, 
                  BRONZE as ANZAHL,
                  'bronze' as FARBE
                  from df
                  ")
ggplot(data=olympia2,aes(x=JAHR,weight=ANZAHL,fill=FARBE)) + geom_bar(stat="bin", binwidth=10)#Bild4

#Tortendiagramm
ggplot(data=olympia2,aes(x=factor(1),weight=ANZAHL,fill=FARBE))+geom_bar(width=1)+coord_polar(theta="y")#Bild 56

#Gruppen
ggplot(data=olympia2,aes(x=JAHR,y=ANZAHL,group=FARBE,colour=FARBE)) + geom_line(size=2)#Bild7

#Facet
ggplot(data=olympia2,aes(x=JAHR,y=ANZAHL)) + geom_line() + facet_grid(FARBE~.)#Bild8
ggplot(data=olympia2,aes(x=JAHR,y=ANZAHL)) + geom_line() + facet_grid(.~FARBE)#Bild9

#Grid
install.packages("gridExtra")
library("gridExtra")
p1 <- ggplot(...)
p2 <- ggplot(...)
grid.arrange( p1, p2, ncol=2)

#Schöner
ps <- ggplot(data=olympia2,aes(x=JAHR,y=ANZAHL,group=FARBE,colour=FARBE))+ geom_line(size=2)
ps + xlim(1975,2014)+ylim(5,20)
ps + labs(title="Überschrift",x="Anzahl",y="Jahr")
ps + theme(legend.title = element_text(colour="blue", size=16, face="bold"))
ps + theme(legend.position="none")
